<?php

/**
 * Implementiert einige Sicherheitseinstellungen wie Passwort ändern, etc.
 * @author Florian Kraatz <fk@beronet.com>
 * @author Sílvia Mariné <smg@beronet.com>
 * @author Miguel Palmer <mp@beronet.com>
 */

include_once('/usr/www/include/SQLite2ToSQLite3.php');

class Security {

	private 	$_bc,
			$_ba;

	private		$m_attr;

	private		$post_attr,
			$post_checked = 0;

	private		$session_attr,
			$session_checked = 1;

	private		$isRequestRejected = 0,
			$reasonRejected = array();

	function __construct($m, $get = array(), $post = array(), $session = array()) {
		$invalid = array();

		// loading class
		$this->_bc = new beroConf('root');
		$this->_ba = new beroAri();
		
		// set main GET variable
		$this->m_attr = $m;

		// check POST variable
		if (isset($post['submit'])) {
			unset($post['m'], $post['f'], $post['fixChrome']);

			// TOTEST: restore admin / password / username coming from an other script
			$list_post = array(	'submit'    => 'select', 'a'	    => 'select'  , 'api_disable' => 'bool'    , 'ssh_admin_enable' => 'bool'	, 'show_app' => 'bool',	
						'safeguard' => 'bool'  , 'pass_old' => 'password', 'pass_new'    => 'password', 'pass_con'	   => 'password'); 

			$list_options_select = array(	'submit'	=> array('Restore admin password and username', 'Save', 'Speichern'), // must rework the class to work with BUTTON_SAVE
							'a'		=> array('save'));

			$this->post_checked = 1;
			$this->post_attr = Helper::sanitizePost($post, $list_post, $this->post_checked, $this->reasonRejected, $list_options_select);

			$this->isRequestRejected = !$this->post_checked;
		}

		// check SESSION variable
		$this->session_checked = 1;
		$this->session_attr['beroari_username'] = Helper::sanitizeSession($session['beroari_username'], 'config-option', $this->session_checked, $this->reasonRejected); // TODO: maybe, find a better checkor than 'config-option'

		$this->isRequestRejected |= !$this->session_checked;
	}

	private function _set_ssh_login($enabled) {
		$this->_bc->set('root', 'ssh_admin_enable', (($enabled == '1') ? '1' : '0'));
		$passwd = '/usr/bin/passwd -' . (($enabled == 1) ? 'u' : 'l') . ' admin';
		exec('/bin/mount -oremount,rw /; ' . $passwd . '; /bin/mount -oremount,ro /');
	}

	private function _set_api_password($user, $pass) {
		require_once('/usr/local/php/include/apiusers.Class.php');
		$apiusers = new apiusers($pass);
		$apiusers->createFile();
	}

	private function _set_ssh_password($user, $pass) {
		exec('/usr/local/sbin/pwchange.sh admin ' . $pass);
	}

	private function _set_gui_password($user, $pass) {
		$pass_enc = tep_encrypt_password($pass);
		$this->_ba->update('UPDATE users SET password = \'' . $pass_enc . '\' WHERE user = \'' . $user . '\'');
	}

	private function _set_passwords($user, $pw_old, $pw_new, $pw_con) {

# we do not like empty passwords
		if ((strlen($pw_new) == 0) || (strlen($pw_old) == 0) || (strlen($pw_con) == 0)) {
			return(1);
		}

# old password should be correct
		$query = $this->_ba->select('SELECT password FROM users WHERE user = \'' . $user . '\'');
		$pw_chk = $this->_ba->fetch_array($query);
		if (tep_validate_password($pw_old, $pw_chk['password']) == false) {
			return(2);
		}
		unset($query);
		unset($pw_chk);

# new password should be the same as confirmation
		if (strcmp($pw_new, $pw_con) != 0) {
			return(3);
		}

		switch ($user) {
			case 'admin':
				$this->_set_api_password($user, $pw_new);
				$this->_set_ssh_password($user, $pw_new);
			case 'beroAdmin':
				$this->_set_gui_password($user, $pw_new);
				break;
		}

		return(0);
	}

	private function _apply_changes($session, $args) {
		if ($args['submit'] == 'Restore admin password and username') {
			$this->_set_api_password('admin', 'admin');
			$this->_set_ssh_password('admin', 'admin');
			$this->_set_gui_password('admin', 'admin');
		} else if ($args['a'] == 'save') {

			// only try to update password if some of the password-fields are set
			if ($this->session_checked && ((strlen($args['pass_old']) != 0) || (strlen($args['pass_new']) != 0) || (strlen($args['pass_con']) != 0))) {
				$res = $this->_set_passwords($session['beroari_username'], $args['pass_old'], $args['pass_new'], $args['pass_con']);
				switch ($res) {
					case 1:
						$ret .= '<script>alert(\'' . SECURITY_EMP_PASS_ERROR_DIS . '\');</script>' . "\n";
						break;
					case 2:
						$ret .= '<script>alert(\'' . SECURITY_OLD_PASS_ERROR_DIS . '\');</script>' . "\n";
						break;
					case 3:
						$ret .= '<script>alert(\'' . SECURITY_CONFIRM_ERROR_DIS . '\');</script>' . "\n";
						break;
					default:
						$ret .= '<script>alert(\'' . SECURITY_SUCCES_MESSAGE_DIS . '\');</script>' . "\n";
						$ret .= '<script>$("#security_mess").hide();</script>';
				}
			}

			$this->_bc->set('root', 'api_disable', (($args['api_disable'] == '1') ? '1' : '0'));


			$this->_set_ssh_login($args['ssh_admin_enable']);
			$this->_ba->update('UPDATE set_app SET show_app=\'' . (($args['show_app'] == '1') ? '1' : '0') . '\'');

			$level = 1;
			if ((($this->_bc->get('root', 'safeguard') == '1') ? '1' : '0') != (($args['safeguard'] == '1') ? '1' : '0')) {
				$this->_bc->set('root', 'safeguard', (($args['safeguard'] == '1') ? '1' : '0'));
				$level = 2;
			}

			$ret .= Helper::activate($level, true, $this->m_attr, ACTIVATE);
		}

		return($ret);
	}

	function display() {
		$name = "SECURITY_TITLE_DIS";
		include('./includes/header.php');

		$alert = '';
		if ($this->post_checked && $this->session_checked) {
			$alert = $this->_apply_changes($this->session_attr, $this->post_attr);
			if ($this->_ba->get('gui_mode') == 'simple')
				$simple_class = 'simple';
		} else if ($this->isRequestRejected) {
			$ret .= Helper::displayErrorMessage($this->reasonRejected['request'], $this->reasonRejected['checkor'], $this->reasonRejected['key']);
		}

		$ret .= $this->_show_table($this->m_attr, $simple_class) . $alert;

		return $ret;
	}

	private function _show_api_session() {
		$query = $this->_ba->select('SELECT show_app FROM set_app');
		while ($entry = $this->_ba->fetch_array($query)) {
			return '<input type="checkbox" name="show_app" value="1"' . (($entry['show_app'] == '1') ? ' checked' : '') . '>';
		}
	}

	private function _show_ssh_enable() {

		$ret = '<input type="checkbox" name="ssh_admin_enable" value="1" ' . (($this->_bc->get('root', 'ssh_admin_enable') == 1) ? 'checked="checked" ' : '') . '>';

		return $ret;
	}

	private function _show_api_disable() {

		$ret = '<input type="checkbox" name="api_disable" value="1" ' . (($this->_bc->get('root', 'api_disable') == '1') ? 'checked="checked" ' : '') . '>';

		return $ret;
	}

	private function _show_safeguard() {

		$ret = '<input type="checkbox" name="safeguard" value="1" ' . (($this->_bc->get('root', 'safeguard') == 1) ? 'checked="checked" ' : '') . '>';

		return $ret;
	}

	private function _show_table($module, $simple_class = null) {
		require_once '/usr/fallback/beroConf.php';
		require_once './includes/lang.php';
		ob_start();
		?>
		<br>
		<br>
		<p class="text-center lead"><?php echo SECURITY_TABLE_HEADER_DIS ?></p>
		<form name="security" id="security" method="POST" class="form-horizontal" autocomplete="off">
			<input name="fixChrome" type="password" style="display:none">
			<input type="hidden" name="m" value="<?php echo $module ?>">
			<input type="hidden" name="f" value="action">
			<input type="hidden" name="a" value="save">
			<div class="form-group" data-toggle="tooltip" title="<?php echo CHANGE_PWD_OLD_PASS ?>">
				<label for='pass_old' class='col-sm-5 control-label'><?php echo SECURITY_OLD_PASS_DIS ?></label>
				<div class='col-sm-4'>
					<input type="password" name="pass_old" class="form-control input-sm" autocomplete="off">
				</div>
			</div>
			<div class="form-group" data-toggle="tooltip" title="<?php echo CHANGE_PWD_NEW_PASS ?>">
				<label for='pass_new' class='col-sm-5 control-label'><?php echo SECURITY_NEW_PASS_DIS ?></label>
				<div class='col-sm-4'>
					<input type="password" name="pass_new" class="form-control input-sm" autocomplete="off">
				</div>
			</div>
			<div class="form-group" data-toggle="tooltip" title="<?php echo CHANGE_PWD_CONFIRM_NEW_PASS ?>">
				<label for='pass_con' class='col-sm-5 control-label'><?php echo SECURITY_CONFIRM_PASS_DIS ?></label>
				<div class='col-sm-4'>
					<input type="password" class="form-control input-sm" name="pass_con" autocomplete="off">
				</div>
			</div>
			<!-- This is where the old thing was; we'd need to change the following in order to change the message (and change it wherever needed)
			-->
			<div class="form-group <?php echo $simple_class ?>" data-toggle="tooltip" title="<?php echo SECURITY_API_DISABLE ?>">
				<label for='api_disable' class='col-sm-5 control-label'><?php echo SECURITY_DISABLE_API_DIS ?></label>
				<div class='col-sm-4'>
					<?php echo $this->_show_api_disable() ?>
				</div>
			</div>
			<div class="form-group" data-toggle="tooltip" title="<?php echo SECURITY_DISABLE_SESSION ?>">
				<label for='show_app' class='col-sm-5 control-label'><?php echo SECURITY_DISABLE_SESSIONS_DIS ?></label>
				<div class='col-sm-4'>
					<?php echo $this->_show_api_session() ?>
				</div>
			</div>
			<div class="form-group <?php echo $simple_class ?>" data-toggle="tooltip" title="<?php echo SECURITY_SSH_ADMIN_ENABLE ?>">
				<label for='ssh_admin_enable' class='col-sm-5 control-label'><?php echo SECURITY_ENABLE_SSH_ADMIN_DIS ?></label>
				<div class='col-sm-4'>
					<?php echo $this->_show_ssh_enable() ?>
				</div>
			</div>
			<div class="form-group <?php echo $simple_class ?>" data-toggle="tooltip" title="<?php echo SECURITY_SAFE_GUARD ?>">
				<label for='safeguard' class='col-sm-5 control-label'><?php echo SECURITY_SAFE_GUARD_DIS ?></label>
				<div class='col-sm-4'>
					<?php echo $this->_show_safeguard() ?>
				</div>
			</div>
			<div class="text-center">
				<input name="submit" type="submit" class="btn btn-default" value="<?php echo BUTTON_SAVE ?>">
			</div>
		</form>
		<script type="text/javascript">
			$('#security').validate({
				rules: {
					pass_new: {
						checkPassword: true,
					},
				}
			});
		</script>
		<?php
		$ret .= ob_get_clean();

		return $ret;
	}

}
?>
